open Types ;;




let (make_gc_list_for_string : index -> string -> gc_list) = fun index str ->
 try
   let positions = !(Hashtbl.find index str) in
   let str_len = (String.length str - 1) in
   List.map (fun start -> (start, start + str_len)) positions
 with
 | Not_found -> []
;;


let rec (tau : gc_list -> position -> extent) = fun s k ->
  if k >= infty then (infty, infty)
  else
  match s with
   | [] -> (infty, infty)
   | (p, q) :: rem ->
       (* On s'appuie sur le fait que les listes sont tries *)
       (* par extents croissants *)
       if k <= p then (p, q) else tau rem k
;;


let rec (rho : gc_list -> position -> extent) = fun s k ->
  if k >= infty then (infty, infty)
  else
  match s with
   | [] -> (infty, infty)
   | (p, q) :: rem ->
       if k <= q then (p, q) else rho rem k
;;



(* Dernier extent terminant  ou avant k *)
let (tau' : gc_list -> position -> extent) = fun s k ->
 let rec go s =
  match s with
   | [] -> (-infty, -infty)
   | (p, q) :: rem ->
       if k >= q then (p, q) else go rem in
 if k <= -infty then (-infty, -infty)
 else go (List.rev s)
;;


let (rho' : gc_list -> position -> extent) = fun s k ->
 let rec go s =
  match s with
   | [] -> (-infty, -infty)
   | (p, q) :: rem ->
       if k >= p then (p, q) else go rem in
 if k <= -infty then (-infty, -infty)
 else go (List.rev s)
;;



let debug_gc_list msg l =
 Format.printf "%s{ @[" msg ;
 List.iter (fun (x, y) -> Format.printf "(%d, %d)@ " x y) l ;
 Format.printf "}@]"
;;
