
{
open Parserequest

exception Lexical_error
}

let lowercase = ['a'-'z' '\223'-'\246' '\248'-'\255']
let uppercase = ['A'-'Z' '\192'-'\214' '\216'-'\222']
let digit = ['0'-'9']
let blank = [' ' '\009' '\012']
let return = [ '\010' '\013']


rule request = parse
  | "&"      { AMPERSAND }
  | "|"      { BAR }
  | return   { RETURN }
  | "("      { LPAREN }
  | ")"      { RPAREN }
  | "["      { LBRACKET }
  | "]"      { RBRACKET }
  | "<>"     { LTGT }
  | "<"      { LT }
  | ">"      { GT }
  | digit+   { NUMBER (int_of_string (Lexing.lexeme lexbuf)) }
  | (lowercase | uppercase)+ (lowercase | uppercase | digit)*
             { TOKEN (Lexing.lexeme lexbuf) }
  | blank+   { request lexbuf }
  | _        { raise Lexical_error }

