open Types ;;
open Request ;;






let create_index filename =
 let file = open_in filename in
 let index = Hashtbl.create 13 in
 let lexbuf = Lexing.from_channel file in
 let continue = ref true in
 while !continue do
   let (word, position) = Lexfile.file lexbuf in
   if word = "" then continue := false
   else
     try
       let entry = Hashtbl.find index word in
       entry := !entry @ [position]
     with Not_found -> Hashtbl.add index word (ref [position])
 done ;
 index
;;


(* ************* *)
let index = create_index Sys.argv.(1) ;;
if Array.length Sys.argv >= 3 && Sys.argv.(2) = "-d"
 then Types.debug := true ;;
let lexbuf = Lexing.from_channel stdin ;;
(*
Hashtbl.iter
  (fun word positions ->
    Printf.printf "Word: '%s' at positions : " word ;
    List.iter (fun p -> Printf.printf " %d" p) !positions ;
    Printf.printf "\n" ;
    flush stdout)
  index ;;
*)
while true do
  try
    Format.printf "?> " ; Format.print_flush () ;
    let request = Parserequest.request Lexrequest.request lexbuf in
    let res_gc_list = Request.driver request index in
    Format.printf "@\n" ;
    Gclist.debug_gc_list "Final Result: " res_gc_list ;
    Format.printf "@\n%d occurences@\n" (List.length res_gc_list) ;
    flush stdout
  with
   | Lexrequest.Lexical_error ->
       Format.printf "Lexical error@\n" ; Format.print_flush ()
   | Parsing.Parse_error ->
       Format.printf "Syntax error@\n" ;  Format.print_flush ()
done ;;
