%{
%}

/* Tokens */
%token AMPERSAND
%token BAR
%token MINUS
%token RETURN
%token <string> TOKEN
%token LPAREN
%token RPAREN
%token LBRACKET
%token RBRACKET
%token LTGT
%token LT
%token GT
%token <int> NUMBER

%right BAR                        /* | */
%right AMPERSAND                  /* & */
%left GT LT LTGT

/* Entry points */
%start request
%type <Request.request> request

%%

/* Entry point */
request:
    subrequest RETURN                 { $1 }
;

subrequest:
   TOKEN                              { Request.Simple $1 }
 | LPAREN subrequest RPAREN           { $2 }
 | subrequest AMPERSAND subrequest    { Request.And ($1, $3) }
 | subrequest BAR subrequest          { Request.Or ($1, $3) }
 | subrequest LTGT subrequest         { Request.Followed_by ($1, $3) }
 | subrequest LT subrequest           { Request.Contained_in ($1, $3) }
 | LBRACKET NUMBER RBRACKET           { Request.Sized $2 }
%%
