(***********************************************************************)
(*                                                                     *)
(*                           The V6 Engine                             *)
(*                                                                     *)
(*          Francois Rouaix, projet Cristal, INRIA Rocquencourt        *)
(*                                                                     *)
(*  Copyright 1996 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

(* $Id: errors.ml,v 1.2 1997/12/16 16:00:29 rouaix Exp $ *)

(* The type of errors *)
type error =
   Unsupported_Protocol of string
 | Fatal of string
 | Invalid_Request of string * string
 | Invalid_Response of string * string
 | Lexical of string * int
 | Proxy of int * string * string
 | Server of int * string * string

exception Error of error

let fatal_error s = raise (Error (Fatal s))
let error err = raise (Error err)

