(***********************************************************************)
(*                                                                     *)
(*                           The V6 Engine                             *)
(*                                                                     *)
(*          Francois Rouaix, projet Cristal, INRIA Rocquencourt        *)
(*                                                                     *)
(*  Copyright 1996 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

(* $Id: errors.mli,v 1.1.1.1 1996/05/28 17:32:23 rouaix Exp $ *)

(* Generic error handling *)

(* The type of errors *)
type error =
   Unsupported_Protocol of string
 | Fatal of string
 | Invalid_Request of string * string
 | Invalid_Response of string * string
 | Lexical of string * int
 | Proxy of int * string * string
 | Server of int * string * string

exception Error of error

val fatal_error : string -> 'a
val error : error -> 'a
  (* raise an error *)

