(********************************************************************** *)
(*                                                                      *)
(*                        Ubi Est - Indexing package                    *)
(*                                                                      *)
(*  Copyright Franois Pessaux 1999-2007.                               *)
(*  Distributed according to the LICENCE file contained in the archive. *)
(*                                                                      *)
(************************************************************************)


type file_name = string ;;

type file_position = int ;;

type file_extent = (file_position * file_position) ;;

type position_mapping = (file_extent * file_name) ;;

type index_data = (Token.t, file_position array) Hashtbl.t ;;

type t = {
    stoplist : Stoplist.t ;
    map : position_mapping array ;
    data : index_data
  } ;;

val version_release : string
val build_command_call : string -> string -> int -> string
