(********************************************************************** *)
(*                                                                      *)
(*                        Ubi Est - Indexing package                    *)
(*                                                                      *)
(*  Copyright Franois Pessaux 1999-2007.                               *)
(*  Distributed according to the LICENCE file contained in the archive. *)
(*                                                                      *)
(************************************************************************)


(* Type des lments dlimitant la structure des documents reconnus *)
type t =
  (* Commentaires *)
  | Comment_start | Comment_stop
  (* Titre *)
  | Title_start | Title_stop
  (* Sectionnement *)
  | Section_start | Section_stop
  | Subsection_start | Subsection_stop
  | Subsubsection_start | Subsubsection_stop
  (* Tables *)
  | Table_start | Table_stop
  (* Mise en relief (em, bf, it, underline) *)
  | Relief_start | Relief_stop
  (* Enumration de cas *)
  | Enum_start | Enum_stop
  (* Fin de fichier (non index dans la base de donnes) *)
  | Eof
;;

let string = function
  | Comment_start -> "--Comment_start--"
  | Comment_stop -> "--Comment_stop--"
  | Title_start -> "--Title_start--"
  | Title_stop -> "--Title_stop--"
  | Section_start -> "--Section_start--"
  | Section_stop -> "--Section_stop--"
  | Subsection_start -> "--Subsection_start--"
  | Subsection_stop -> "--Subsection_stop--"
  | Subsubsection_start -> "--Subsubsection_start--"
  | Subsubsection_stop -> "--Subsubsection_stop--"
  | Table_start -> "--Table_start--"
  | Table_stop -> "--Table_stop--"
  | Relief_start -> "--Relief_start--"
  | Relief_stop -> "--Relief_stop--"
  | Enum_start -> "--Enum_start--"
  | Enum_stop -> "--Enum_stop--"
  | Eof -> "--Eof--"
;;
