(********************************************************************** *)
(*                                                                      *)
(*                        Ubi Est - Indexing package                    *)
(*                                                                      *)
(*  Copyright Franois Pessaux 1999-2007.                               *)
(*  Distributed according to the LICENCE file contained in the archive. *)
(*                                                                      *)
(************************************************************************)


type request =
  | Simple of Token.t
  | And of request * request
  | Or of request * request
  | Followed_by of request * request
  | Contained_in of request * request
  | Containing of request * request
  | Not_contained_in of request * request
  | Not_containing of request * request

val driver : request -> Index.t -> Gclist.extent list
val verify_request : Stoplist.t -> request -> bool
