(********************************************************************** *)
(*                                                                      *)
(*                        Ubi Est - Indexing package                    *)
(*                                                                      *)
(*  Copyright Franois Pessaux 1999-2007.                               *)
(*  Distributed according to the LICENCE file contained in the archive. *)
(*                                                                      *)
(************************************************************************)

(* **************************
Dtermination du format d'un fichier. Gre en dur les fichiers 'tar'.
************************** *)
let get filename =
  let file = open_in filename in
  let fformat_lexbuf = Lexing.from_channel file in
  let format = Fileformat.file fformat_lexbuf in
  (* Pendant que le fichier est ouvert, on regarde s'il comporte une *)
  (* signature 'tar' comme a ce sera fait.                          *)
  seek_in file 257 ;
  let tar_sig = (try
    let tmp0 = input_byte file in let tmp1 = input_byte file in
    let tmp2 = input_byte file in let tmp3 = input_byte file in
    let tmp4 = input_byte file in (tmp0, tmp1, tmp2, tmp3, tmp4)
  with End_of_file -> (-1, -1, -1, -1, -1)) in
  (* Maintenant on n'a plus besoin du fichier, on peut fermer. *)
  close_in file ;
  let format' = (match tar_sig with
     (0x75, 0x73, 0x74, 0x61, 0x72) -> Fileformat.Tar | _ -> format) in
  format'
;;
