
{
(********************************************************************** *)
(*                                                                      *)
(*                        Ubi Est - Indexing package                    *)
(*                                                                      *)
(*  Copyright Franois Pessaux 1999-2007.                               *)
(*  Distributed according to the LICENCE file contained in the archive. *)
(*                                                                      *)
(************************************************************************)

}

let lowercase = ['a'-'z' '\223'-'\246' '\248'-'\255' '_']
let uppercase = ['A'-'Z' '\192'-'\214' '\216'-'\222']
let digit = ['0'-'9']

rule file = parse
  | (lowercase | uppercase)+ (lowercase | uppercase | digit)*
      {
	let word = String.lowercase (Lexing.lexeme lexbuf) in
	(* Handle stop-list *)
	if Stoplist.mem word !GlobalStoplist.stop_list then file lexbuf
	else (Token.Text word, Lexing.lexeme_start lexbuf)
      }
  | eof
      {
	(* Return the ending offset of the file includes the eof character. *)
	(* == Taille du fichier *)
	(Token.Markup Markup.Eof, Lexing.lexeme_start lexbuf)
      }
  | _
      {
	file lexbuf
      }
